package net.mcreator.puzzle_code.client.gui;

import net.neoforged.neoforge.network.PacketDistributor;

import net.minecraft.world.level.Level;
import net.minecraft.world.entity.player.Player;
import net.minecraft.world.entity.player.Inventory;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.network.chat.Component;
import net.minecraft.client.gui.screens.inventory.AbstractContainerScreen;
import net.minecraft.client.gui.components.WidgetSprites;
import net.minecraft.client.gui.components.ImageButton;
import net.minecraft.client.gui.components.Button;
import net.minecraft.client.gui.GuiGraphics;

import net.mcreator.puzzle_code.world.inventory.TransferNeutralCodeBlockGUI2Menu;
import net.mcreator.puzzle_code.procedures.ReturnNBTTypeProcedure;
import net.mcreator.puzzle_code.procedures.IsDisabledDisplayOnProcedure;
import net.mcreator.puzzle_code.network.TransferNeutralCodeBlockGUI2ButtonMessage;

import java.util.HashMap;

import com.mojang.blaze3d.systems.RenderSystem;

public class TransferNeutralCodeBlockGUI2Screen extends AbstractContainerScreen<TransferNeutralCodeBlockGUI2Menu> {
	private final static HashMap<String, Object> guistate = TransferNeutralCodeBlockGUI2Menu.guistate;
	private final Level world;
	private final int x, y, z;
	private final Player entity;
	Button button_number;
	Button button_logic;
	Button button_text;
	Button button_1;
	Button button_2;
	ImageButton imagebutton_question_mark_button;
	ImageButton imagebutton_off_button;
	ImageButton imagebutton_on_button;

	public TransferNeutralCodeBlockGUI2Screen(TransferNeutralCodeBlockGUI2Menu container, Inventory inventory, Component text) {
		super(container, inventory, text);
		this.world = container.world;
		this.x = container.x;
		this.y = container.y;
		this.z = container.z;
		this.entity = container.entity;
		this.imageWidth = 176;
		this.imageHeight = 112;
	}

	private static final ResourceLocation texture = ResourceLocation.parse("puzzle_code:textures/screens/transfer_neutral_code_block_gui_2.png");

	@Override
	public void render(GuiGraphics guiGraphics, int mouseX, int mouseY, float partialTicks) {
		this.renderBackground(guiGraphics, mouseX, mouseY, partialTicks);
		super.render(guiGraphics, mouseX, mouseY, partialTicks);
		this.renderTooltip(guiGraphics, mouseX, mouseY);
		if (mouseX > leftPos + 146 && mouseX < leftPos + 166 && mouseY > topPos + 61 && mouseY < topPos + 81)
			guiGraphics.renderTooltip(font, Component.translatable("gui.puzzle_code.transfer_neutral_code_block_gui_2.tooltip_empty"), mouseX, mouseY);
	}

	@Override
	protected void renderBg(GuiGraphics guiGraphics, float partialTicks, int gx, int gy) {
		RenderSystem.setShaderColor(1, 1, 1, 1);
		RenderSystem.enableBlend();
		RenderSystem.defaultBlendFunc();
		guiGraphics.blit(texture, this.leftPos, this.topPos, 0, 0, this.imageWidth, this.imageHeight, this.imageWidth, this.imageHeight);
		RenderSystem.disableBlend();
	}

	@Override
	public boolean keyPressed(int key, int b, int c) {
		if (key == 256) {
			this.minecraft.player.closeContainer();
			return true;
		}
		return super.keyPressed(key, b, c);
	}

	@Override
	protected void renderLabels(GuiGraphics guiGraphics, int mouseX, int mouseY) {
		guiGraphics.drawString(this.font, Component.translatable("gui.puzzle_code.transfer_neutral_code_block_gui_2.label_nbt_type"), 6, 30, -12829636, false);
		guiGraphics.drawString(this.font, Component.translatable("gui.puzzle_code.transfer_neutral_code_block_gui_2.label_nbt_nbttype"), 6, 43, -12829636, false);
		guiGraphics.drawString(this.font,

				ReturnNBTTypeProcedure.execute(world, x, y, z), 60, 30, -12829636, false);
		guiGraphics.drawString(this.font, Component.translatable("gui.puzzle_code.transfer_neutral_code_block_gui_2.label_is_disabled"), 20, 66, -12829636, false);
	}

	@Override
	public void init() {
		super.init();
		button_number = Button.builder(Component.translatable("gui.puzzle_code.transfer_neutral_code_block_gui_2.button_number"), e -> {
			if (true) {
				PacketDistributor.sendToServer(new TransferNeutralCodeBlockGUI2ButtonMessage(0, x, y, z));
				TransferNeutralCodeBlockGUI2ButtonMessage.handleButtonAction(entity, 0, x, y, z);
			}
		}).bounds(this.leftPos + 6, this.topPos + 7, 54, 20).build();
		guistate.put("button:button_number", button_number);
		this.addRenderableWidget(button_number);
		button_logic = Button.builder(Component.translatable("gui.puzzle_code.transfer_neutral_code_block_gui_2.button_logic"), e -> {
			if (true) {
				PacketDistributor.sendToServer(new TransferNeutralCodeBlockGUI2ButtonMessage(1, x, y, z));
				TransferNeutralCodeBlockGUI2ButtonMessage.handleButtonAction(entity, 1, x, y, z);
			}
		}).bounds(this.leftPos + 65, this.topPos + 7, 54, 20).build();
		guistate.put("button:button_logic", button_logic);
		this.addRenderableWidget(button_logic);
		button_text = Button.builder(Component.translatable("gui.puzzle_code.transfer_neutral_code_block_gui_2.button_text"), e -> {
			if (true) {
				PacketDistributor.sendToServer(new TransferNeutralCodeBlockGUI2ButtonMessage(2, x, y, z));
				TransferNeutralCodeBlockGUI2ButtonMessage.handleButtonAction(entity, 2, x, y, z);
			}
		}).bounds(this.leftPos + 123, this.topPos + 7, 45, 20).build();
		guistate.put("button:button_text", button_text);
		this.addRenderableWidget(button_text);
		button_1 = Button.builder(Component.translatable("gui.puzzle_code.transfer_neutral_code_block_gui_2.button_1"), e -> {
			if (true) {
				PacketDistributor.sendToServer(new TransferNeutralCodeBlockGUI2ButtonMessage(3, x, y, z));
				TransferNeutralCodeBlockGUI2ButtonMessage.handleButtonAction(entity, 3, x, y, z);
			}
		}).bounds(this.leftPos + 65, this.topPos + 84, 18, 20).build();
		guistate.put("button:button_1", button_1);
		this.addRenderableWidget(button_1);
		button_2 = Button.builder(Component.translatable("gui.puzzle_code.transfer_neutral_code_block_gui_2.button_2"), e -> {
			if (true) {
				PacketDistributor.sendToServer(new TransferNeutralCodeBlockGUI2ButtonMessage(4, x, y, z));
				TransferNeutralCodeBlockGUI2ButtonMessage.handleButtonAction(entity, 4, x, y, z);
			}
		}).bounds(this.leftPos + 92, this.topPos + 84, 18, 20).build();
		guistate.put("button:button_2", button_2);
		this.addRenderableWidget(button_2);
		imagebutton_question_mark_button = new ImageButton(this.leftPos + 146, this.topPos + 61, 20, 20,
				new WidgetSprites(ResourceLocation.parse("puzzle_code:textures/screens/question_mark_button.png"), ResourceLocation.parse("puzzle_code:textures/screens/question_mark_button_highlight.png")), e -> {
				}) {
			@Override
			public void renderWidget(GuiGraphics guiGraphics, int x, int y, float partialTicks) {
				guiGraphics.blit(sprites.get(isActive(), isHoveredOrFocused()), getX(), getY(), 0, 0, width, height, width, height);
			}
		};
		guistate.put("button:imagebutton_question_mark_button", imagebutton_question_mark_button);
		this.addRenderableWidget(imagebutton_question_mark_button);
		imagebutton_off_button = new ImageButton(this.leftPos + 101, this.topPos + 61, 40, 20,
				new WidgetSprites(ResourceLocation.parse("puzzle_code:textures/screens/off_button.png"), ResourceLocation.parse("puzzle_code:textures/screens/off_button_highlight.png")), e -> {
					if (true) {
						PacketDistributor.sendToServer(new TransferNeutralCodeBlockGUI2ButtonMessage(6, x, y, z));
						TransferNeutralCodeBlockGUI2ButtonMessage.handleButtonAction(entity, 6, x, y, z);
					}
				}) {
			@Override
			public void renderWidget(GuiGraphics guiGraphics, int x, int y, float partialTicks) {
				guiGraphics.blit(sprites.get(isActive(), isHoveredOrFocused()), getX(), getY(), 0, 0, width, height, width, height);
			}
		};
		guistate.put("button:imagebutton_off_button", imagebutton_off_button);
		this.addRenderableWidget(imagebutton_off_button);
		imagebutton_on_button = new ImageButton(this.leftPos + 101, this.topPos + 61, 40, 20,
				new WidgetSprites(ResourceLocation.parse("puzzle_code:textures/screens/on_button.png"), ResourceLocation.parse("puzzle_code:textures/screens/on_button_highlight.png")), e -> {
				}) {
			@Override
			public void renderWidget(GuiGraphics guiGraphics, int x, int y, float partialTicks) {
				if (IsDisabledDisplayOnProcedure.execute(world, x, y, z))
					guiGraphics.blit(sprites.get(isActive(), isHoveredOrFocused()), getX(), getY(), 0, 0, width, height, width, height);
			}
		};
		guistate.put("button:imagebutton_on_button", imagebutton_on_button);
		this.addRenderableWidget(imagebutton_on_button);
	}
}
